/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: altcpu.c,v 1.3 2002/11/26 22:23:10 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/07/02
 *
 *-----------------------------------------------------------------
 */

#include "nfx-incl.h"
#include "smp-api.h"
#ifdef DMALLOC
#include "dmalloc.h"
#endif

#ifdef NFX_SMP

extern address_t	get_cpu_startvectors_addr();
typedef address_t	vects[4][4];

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/07/02
 *
 *-----------------------------------------------------------------
 */
int32
altcpu_start(
	int32	cpu_num,
	void	* start_address
)
{
	vects			* vectors;
	extern uchar8	* _gp;
	address_t		sp;

	printf("altcpu_start(%d, %p)\n", cpu_num, start_address);

	vectors = (vects *)get_cpu_startvectors_addr();

	sp = (address_t)smp_stack[cpu_num];
	printf("writing 0x%lx to %p\n", sp+STKSIZE-24, &((*vectors)[cpu_num][1]));
	(*vectors)[cpu_num][1] = sp+STKSIZE-24;
	printf("writing %p to %p\n", &_gp, &((*vectors)[cpu_num][2]));
	(*vectors)[cpu_num][2] = (address_t)&_gp;
	printf("writing 0x%x to %p\n", cpu_num, &((*vectors)[cpu_num][3]));
	(*vectors)[cpu_num][3] = cpu_num;
	printf("writing %p to %p\n", start_address, &((*vectors)[cpu_num][0]));
	(*vectors)[cpu_num][0] = (address_t)start_address;

	return 0;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/07/02
 *
 *-----------------------------------------------------------------
 */
int32
altcpu_cmd(
	int32	argc,
	uchar8	* argv[]
)
{
//	uint64	t;
	extern void smp_entry();

	if (strncmp(argv[1], "start", 5) == 0) {
#if 1
		altcpu_start(1, (void *)smp_entry);
#else
		if (argc != 3)
			printf("altcpu start <addr>\n");
		else
			altcpu_start(1, (void *)atollx(&t, argv[2]));
#endif
	}
	else if (strncmp(argv[1], "stop", 4) == 0) {
	}
	else
		return -1;

	return 0;
}

#endif	/* NFX_SMP */

